;  "ASCII Character Set"
;  For Bally Arcade/Astrocade
;  By Andy Guevara
;  1982
;
;  This little routine will print the entire MLM 3x5 character set.
;   
;       A word of explanation...

;       DJNZ uses the B register as a counter.  Whatever is in B, when this
;  instruction takes place, is decremented.  If the result is not zero,
;  the displacement after the '10' opcode is added to the P-counter.
;  In this case it's 0FCH or -4 Decimal. Since the P-counter has moved
;  on to the next full instruction at 4F3B, the displacement is added
;  to this number to produce the address 4F37 which we have dubbed "HERE".
;
;       If the result of decrementing the B register is zero, no
;  displacement is added to the P-counter and execution continues with
;  the next instruction.
;
;  This assembly source code is from the "Machine Language Manager"
;  Manual, Page 7-6.
;
;  This program is for use with the 1982's "Machine Language Manager"
;  cartridge by The Bit Fiddlers.  The output of this program
;  must be loaded to a 300-baud "tape" and then loaded into the
;  "MLM" at memory address $4F30: 
;
;  This program can be assembled using the ZMAC assembler.  Type:
;
;      zmac -i -m -o ASCII.bin -x ASCII.lst ASCII.asm
;
;  Version History:
;    .01 (July 29, 2013) - Assemly re-typed and commented by Adam Trionfo
;                        - This source has been kept as true to the
;                          original as possible, which is why it doesn't
;                          use HVGLIB.H and instead uses equates for
;                          CALLs to the ROM routines.

;  Equates        
        
CRLF    EQU    $2405
        
        ORG     $4F30
        
        CALL    CRLF         ; Go to next line 
        LD      B,$3B        ; Set up counter
        LD      A,$20        ; First character
HERE    RST     $10          ; Print it                    
        INC     A            ; Get next one
        DJNZ    HERE         ; Loop back
        RET                  ; Go home     

END

